# /bin/sh

KDUMPSUCCESS=$1
CRASHDCSUCCESS=0

if [[ -r /etc/sysconfig/crashdc ]];then
        . /etc/sysconfig/crashdc
else
        echo "The file /etc/sysconfig/crashdc is absent. Cannot run"
        exit 1
fi

coredir=`ls -rtd ${VMCOREDIR}/2* | cut -d\  -f2 | tail -1`
namelist=/usr/lib/debug/lib/modules/$(uname -r)/vmlinux

LOGGER="/usr/bin/logger -p info -t crashdc"

if ! [ -r $namelist ];then
	$LOGGER "Unable to locate $namelist. Verify that the kernel-debuginfo packages are correctly installed."
	exit 1
fi
if [ $KDUMPSUCCESS == 0 ];then
	$CRASHDC $CRASHDCDEBUG $namelist $coredir/vmcore $coredir
	CRASHDCSUCCESS=$?
	if [ $CRASHDCSUCCESS == 0 ];then
		$LOGGER "generated a crash-data file to $coredir"
		exit 0
	else
		$LOGGER "Unable to generate a crash-data file"
		exit 1
	fi
fi
