# /bin/sh

#KDUMPSUCCESS=$1
#
# Changed for test
#
KDUMPSUCCESS=0
CRASHDCSUCCESS=0

. /etc/sysconfig/crashdc
. /etc/sysconfig/kdump
. /etc/rc.status

KDUMP_CLEANUP_DUMPS=/usr/sbin/kdump-cleanup_dumps
KDUMP_SAVE_DUMP=/usr/sbin/kdump-save_dump

# Clean up old stuff if necessary, check the free size
# and save the vmcore
save_core()
{
    $KDUMP_CLEANUP_DUMPS
    if [ "$?" -ne 0 ] ; then
	rc_status -v
	return 1
    fi

    $KDUMP_SAVE_DUMP /proc/vmcore
    rc_status -v

    return 0
}

#
# execute the save_core function similar to the one in
# /etc/init.d/kdump since it's not being done when
# KDUMP_TRANSFER is used.
#
save_core
KDUMPSUCCESS=$?

if [ $KDUMPSUCCESS == 0 ];then
	coredir=${VMCOREDIR}/`ls -rt ${VMCOREDIR} | cut -d\  -f2 | tail -1`
	namelist=/boot/vmlinux-$(uname -r)
	namelist=${namelist%-kdump}-default
	namelist=${namelist}.gz
	if ! [ -r $namelist ];then
		#
		# namelist might have been uncompressed
		#
		if [ -f ${namelist%.gz} ];then
			namelist=${namelist%.gz}
		else
			$LOGGER "Unable to locate $namelist. Verify that the kernel-debuginfo packages are correctly installed."
			false
			rc_status -v
			exit 1
		fi
	fi

	$CRASHDC $CRASHDCDEBUG $namelist $coredir/vmcore $coredir
	CRASHDCSUCCESS=$?
	if [ $CRASHDCSUCCESS == 0 ];then
		$LOGGER "generated a crash-data file to $coredir"
		rc_status -v
		exit 0
	else
		$LOGGER "Unable to generate a crash-data file"
		rc_status -v
		exit 1
	fi
fi
